/*
 * Copyright LWJGL. All rights reserved.
 * License terms: https://www.lwjgl.org/license
 * MACHINE GENERATED FILE, DO NOT EDIT
 */
#include "common_tools.h"
#include <stdint.h>

#ifdef LWJGL_WINDOWS
    #define APIENTRY __stdcall
#else
    #define APIENTRY
#endif

typedef struct HmdMatrix34_t
{
    float m[3][4];
} HmdMatrix34_t;

typedef struct HmdMatrix44_t
{
    float m[4][4];
} HmdMatrix44_t;

typedef struct HmdVector2_t
{
    float v[2];
} HmdVector2_t;

typedef struct HmdColor_t
{
    float r;
    float g;
    float b;
    float a;
} HmdColor_t;

typedef struct HiddenAreaMesh_t
{
    struct HmdVector2_t * pVertexData;
    uint32_t unTriangleCount;
    #ifdef LWJGL_x64
        char __padding[4];
    #endif
} HiddenAreaMesh_t;

typedef HmdMatrix44_t (APIENTRY *VRSystem_GetProjectionMatrixPROC) (jint, jfloat, jfloat);
typedef HmdMatrix34_t (APIENTRY *VRSystem_GetEyeToHeadTransformPROC) (jint);
typedef HmdMatrix34_t (APIENTRY *VRSystem_GetSeatedZeroPoseToStandingAbsoluteTrackingPosePROC) (void);
typedef HmdMatrix34_t (APIENTRY *VRSystem_GetRawZeroPoseToStandingAbsoluteTrackingPosePROC) (void);
typedef HmdMatrix34_t (APIENTRY *VRSystem_GetMatrix34TrackedDevicePropertyPROC) (jint, jint, intptr_t);
typedef HiddenAreaMesh_t (APIENTRY *VRSystem_GetHiddenAreaMeshPROC) (jint, jint);

EXTERN_C_ENTER

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetProjectionMatrix(jint eEye, jfloat fNearZ, jfloat fFarZ, jlong __functionAddress, jlong __result) {
    VRSystem_GetProjectionMatrixPROC VRSystem_GetProjectionMatrix = (VRSystem_GetProjectionMatrixPROC)(intptr_t)__functionAddress;
    *((HmdMatrix44_t*)(intptr_t)__result) = VRSystem_GetProjectionMatrix(eEye, fNearZ, fFarZ);
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetProjectionMatrix(JNIEnv *__env, jclass clazz, jint eEye, jfloat fNearZ, jfloat fFarZ, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetProjectionMatrix(eEye, fNearZ, fFarZ, __functionAddress, __result);
}

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetEyeToHeadTransform(jint eEye, jlong __functionAddress, jlong __result) {
    VRSystem_GetEyeToHeadTransformPROC VRSystem_GetEyeToHeadTransform = (VRSystem_GetEyeToHeadTransformPROC)(intptr_t)__functionAddress;
    *((HmdMatrix34_t*)(intptr_t)__result) = VRSystem_GetEyeToHeadTransform(eEye);
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetEyeToHeadTransform(JNIEnv *__env, jclass clazz, jint eEye, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetEyeToHeadTransform(eEye, __functionAddress, __result);
}

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetSeatedZeroPoseToStandingAbsoluteTrackingPose(jlong __functionAddress, jlong __result) {
    VRSystem_GetSeatedZeroPoseToStandingAbsoluteTrackingPosePROC VRSystem_GetSeatedZeroPoseToStandingAbsoluteTrackingPose = (VRSystem_GetSeatedZeroPoseToStandingAbsoluteTrackingPosePROC)(intptr_t)__functionAddress;
    *((HmdMatrix34_t*)(intptr_t)__result) = VRSystem_GetSeatedZeroPoseToStandingAbsoluteTrackingPose();
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetSeatedZeroPoseToStandingAbsoluteTrackingPose(JNIEnv *__env, jclass clazz, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetSeatedZeroPoseToStandingAbsoluteTrackingPose(__functionAddress, __result);
}

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetRawZeroPoseToStandingAbsoluteTrackingPose(jlong __functionAddress, jlong __result) {
    VRSystem_GetRawZeroPoseToStandingAbsoluteTrackingPosePROC VRSystem_GetRawZeroPoseToStandingAbsoluteTrackingPose = (VRSystem_GetRawZeroPoseToStandingAbsoluteTrackingPosePROC)(intptr_t)__functionAddress;
    *((HmdMatrix34_t*)(intptr_t)__result) = VRSystem_GetRawZeroPoseToStandingAbsoluteTrackingPose();
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetRawZeroPoseToStandingAbsoluteTrackingPose(JNIEnv *__env, jclass clazz, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetRawZeroPoseToStandingAbsoluteTrackingPose(__functionAddress, __result);
}

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetMatrix34TrackedDeviceProperty(jint unDeviceIndex, jint prop, jlong pErrorAddress, jlong __functionAddress, jlong __result) {
    VRSystem_GetMatrix34TrackedDevicePropertyPROC VRSystem_GetMatrix34TrackedDeviceProperty = (VRSystem_GetMatrix34TrackedDevicePropertyPROC)(intptr_t)__functionAddress;
    intptr_t pError = (intptr_t)pErrorAddress;
    *((HmdMatrix34_t*)(intptr_t)__result) = VRSystem_GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pError);
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetMatrix34TrackedDeviceProperty(JNIEnv *__env, jclass clazz, jint unDeviceIndex, jint prop, jlong pErrorAddress, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetMatrix34TrackedDeviceProperty(unDeviceIndex, prop, pErrorAddress, __functionAddress, __result);
}

JNIEXPORT void JNICALL JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetHiddenAreaMesh(jint eEye, jint type, jlong __functionAddress, jlong __result) {
    VRSystem_GetHiddenAreaMeshPROC VRSystem_GetHiddenAreaMesh = (VRSystem_GetHiddenAreaMeshPROC)(intptr_t)__functionAddress;
    *((HiddenAreaMesh_t*)(intptr_t)__result) = VRSystem_GetHiddenAreaMesh(eEye, type);
}
JNIEXPORT void JNICALL Java_org_lwjgl_openvr_VRSystem_nVRSystem_1GetHiddenAreaMesh(JNIEnv *__env, jclass clazz, jint eEye, jint type, jlong __functionAddress, jlong __result) {
    UNUSED_PARAMS(__env, clazz)
    JavaCritical_org_lwjgl_openvr_VRSystem_nVRSystem_1GetHiddenAreaMesh(eEye, type, __functionAddress, __result);
}

EXTERN_C_EXIT
